<?php
/*
 * [NOS][SNA] (C)2007-2011 Maiyun.NET
 * This is NOT a freeware, use is subject to license terms.
 *
 * Log: 2011-10-31 23:15:02 8 yunboo
*/

if(!function_exists('bcadd')) {
	$bcmath_scale = 0;

	function bcadd($left_operand, $right_operand, $scale = -1) {
		global $bcmath_scale;
		$s = ($scale!=-1)?$scale:$bcmath_scale;
		return round($left_operand + $right_operand ,$s);
	}

	function bccomp($left_operand, $right_operand, $scale = -1) {
		$left_operand = $left_operand + 0;
		$right_operand = $right_operand + 0;
		if($left_operand > $right_operand) return 1;
		else if($left_operand == $right_operand) return 0;
		else return -1;
	}

	function bcdiv($left_operand, $right_operand, $scale = -1) {
		global $bcmath_scale;
		$s = ($scale!=-1)?$scale:$bcmath_scale;
		return round($left_operand / $right_operand ,$s);
	}

	function bcmod($left_operand, $modulus) {
		return $left_operand % $modulus;
	}

	function bcmul($left_operand, $right_operand, $scale = -1) {
		global $bcmath_scale;
		$s = ($scale!=-1)?$scale:$bcmath_scale;
		return round($left_operand * $right_operand ,$s);
	}

	function bcscale($scale) {
		global $bcmath_scale;
		$bcmath_scale = $scale;
	}

	function bcsub($left_operand, $right_operand, $scale = -1) {
		global $bcmath_scale;
		$s = ($scale!=-1)?$scale:$bcmath_scale;
		return round($left_operand - $right_operand ,$s);
	}
}

