<?php
/*
 * [NOS][SNA] (C)2007-2011 Maiyun.NET
 * This is NOT a freeware, use is subject to license terms.
 *
 * Log: 2011-10-29 22:59:26 8 yunboo
*/

define('ROOT_PATH', substr(dirname(__FILE__), 0, -7));
define('USING_SYSTEM', true);

include_once(ROOT_PATH.'data/config.data.php');
include_once(ROOT_PATH.'include/mysql.lib.php');
include_once(ROOT_PATH.'include/network.lib.php');
include_once(ROOT_PATH.'include/json.lib.php');
include_once(ROOT_PATH.'include/bcmath.lib.php');

bcscale(0);

// --- 数据 ---

function read_data($file,$folder = 'config') {
	$CONFIG_PATH = ROOT_PATH.'data/'.$folder.'/';
	if(is_file($CONFIG_PATH.$file.'.php')) {
		return unserialize(substr(file_get_contents($CONFIG_PATH.$file.'.php'),15,-3));
	} else {
		return false;
	}
}

function write_data($file,$arr,$folder = 'config') {
	$CONFIG_PATH = ROOT_PATH.'data/'.$folder.'/';
	if(!is_dir($CONFIG_PATH)) mkdir($CONFIG_PATH, 0777, true);
	$arr['nos_date'] = time();
	return file_put_contents($CONFIG_PATH.$file.'.php','<?php exit; /* '.serialize($arr).' */');
}

function nos_setcookie($name,$val,$expires=NULL,$path='/',$domain=NULL) {
	setcookie($name,$val,$expires,$path,$domain,$_SERVER['SERVER_PORT']==443?1:0);
}

// --- 字符串 ---

function random_string($Length = 8,$mode = 0) {
	if($mode==0) $source='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
	elseif($mode==1) $source='abcdefghijklmnopqrstuvwxyz0123456789';
	$Temp = '';
	$SourceLen = strlen($source)-1;
	for ($i = $Length; $i; $i--)
		$Temp .= $source[rand(0, $SourceLen)];
	return $Temp;
}

// --- CACHE ---

function no_cache() {
	header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
	header('Last-Modified: '.gmdate("D, d M Y H:i:s").' GMT');
	header('Cache-Control: no-cache, must-revalidate');
	header('Pramga: no-cache');
}

// --- 文件 ---

function format_filesize($filesize) {
	if(bccomp($filesize, '1125899906842624') >= 0)
		return bcdiv($filesize ,'1125899906842624' ,2) . 'P';
	elseif(bccomp($filesize, '1099511627776') >= 0)
		return bcdiv($filesize ,'1099511627776' ,2) . 'T';
	elseif(bccomp($filesize, '1073741824') >= 0)
		return bcdiv($filesize ,'1073741824' ,2) . 'G';
	elseif(bccomp($filesize, '1048576') >= 0)
		return bcdiv($filesize ,'1048576' ,2) . 'M';
	elseif(bccomp($filesize, '1024') >= 0)
		return bcdiv($filesize ,'1024' ,2) . 'K';
	else
		return $filesize . 'B';
}

// --- 获取页码翻页 ---

function get_page_html($total,$split,$now,$nhtml,$shtml) {
	$page = $total%$split?(int)($total/$split)+1:$total/$split;
	$now = (($now<=0)||($now>$page))?1:$now;
	$start = $now==1?0:($now-1)*$split;
	$html = '';
	for($i=$now-1,$j=0;($i>0)&&($j<5);$i--,$j++) {
		$html = str_replace('[p]',$i,$nhtml).$html;
	}
	$html .= str_replace('[p]',$now,$shtml);
	for($i=$now+1,$j=0;($i<=$page)&&($j<5);$i++,$j++) {
		$html .= str_replace('[p]',$i,$nhtml);
	}
	return array(
		'html' => $html,
		'limit' => $start,
		'page' => $page
	);
}

// --- 加密解密 ---

function authcode($string, $operation = 'DECODE', $key = '', $expiry = 0) {
	$ckey_length = 4;

	$key = md5($key);
	$keya = md5(substr($key, 0, 16));
	$keyb = md5(substr($key, 16, 16));
	$keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length): substr(md5(microtime()), -$ckey_length)) : '';

	$cryptkey = $keya.md5($keya.$keyc);
	$key_length = strlen($cryptkey);

	$string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0).substr(md5($string.$keyb), 0, 16).$string;
	$string_length = strlen($string);

	$result = '';
	$box = range(0, 255);

	$rndkey = array();
	for($i = 0; $i <= 255; $i++) {
		$rndkey[$i] = ord($cryptkey[$i % $key_length]);
	}

	for($j = $i = 0; $i < 256; $i++) {
		$j = ($j + $box[$i] + $rndkey[$i]) % 256;
		$tmp = $box[$i];
		$box[$i] = $box[$j];
		$box[$j] = $tmp;
	}

	for($a = $j = $i = 0; $i < $string_length; $i++) {
		$a = ($a + 1) % 256;
		$j = ($j + $box[$a]) % 256;
		$tmp = $box[$a];
		$box[$a] = $box[$j];
		$box[$j] = $tmp;
		$result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
	}

	if($operation == 'DECODE') {
		if((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26).$keyb), 0, 16)) {
			return substr($result, 26);
		} else {
			return '';
		}
	} else {
		return $keyc.str_replace('=', '', base64_encode($result));
	}

}

